//RechercherNuance_304f.js
// 10.08.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Sert  dtecter l'utilisation d'une nuance spcifique

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester la version du programme
var appVers = app.version[0];
if (appVers != 6) {
	if (appVers == 4) {
		alert ("Avec InDesign CS2\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else if (appVers == 5) {
		alert ("Avec InDesign CS3\nil faut utiliser la version correspondante du script.", "Attention");
	}
	else {
		alert ("Il ne faut utiliser ce script qu'avec InDesign CS4.", "Attention");
	}
	exit();
}

// tester, s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.");
	exit();
}

curDoc = app.documents[0];

// dresser la liste des couleurs dfinies par l'utilisateur
var allSwatches = curDoc.swatches;
var curSwatch, cName;
var colorList = new Array();
for (var i=0; i<allSwatches.length; i++) {
	curSwatch = allSwatches.item(i);
	cName = curSwatch.name;
	if (cName != "None" && cName != "Black" && cName != "Paper" && cName != "Registration") {
		colorList.push(cName);
	}
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// demander le nom de la nuance  rechercher
var aDialog = app.dialogs.add({name:"Nuances disponibles", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Slectionner la nuance  rechercher"});
				var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
			}
		}
	}
}

// montrer le dialogue
if (aDialog.show() == true) {
	var selColor, aOffset, aTint;
	// reprendre le choix de l'utilisateur
	// le nom de la couleur est l'lment 'selectedIndex' de l'array 'colorList'
	selColor = colorList[colorNames.selectedIndex];
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

//--- dresser la liste des styles de paragraphes...---//
var allParaStyles = curDoc.paragraphStyles;
var nParaStyles = allParaStyles.length;

// une boucle  travers la liste, le compteur commence  "1", 
// ainsi on vite "[Aucune]" (non ditable)
var curList, newList, tmpList, defList;
var curProps, newString;
var defString = "";
var pCtr = 0;
var curName, unc, ungc, stc, stgc;
for (var i=1; i<nParaStyles; i++) {
	curList = new Array ();
	curProps = allParaStyles[i].properties;
	defList = testParaStyles(curProps);
	if (defList.length > 0) {
		pCtr++;
		curName = allParaStyles[i].name;
		curList.push("Style de paragraphes \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("\r");
		defString = defString + newString + "\r\r";
	}
}

//--- lister les groupes de styles de paragraphes...---//
var allGroups = curDoc.paragraphStyleGroups;
var nParaStyleGroups = allGroups.length;
var curGroup, curParaStyles, nParaStyles;
for (var i=0; i<nParaStyleGroups; i++) {
	curGroup = allGroups[i];
	curParaStyles = curGroup.allParagraphStyles;
	nParaStyles = curParaStyles.length;
	for (var k=0; k<nParaStyles; k++) {
		curProps = curParaStyles[k].properties;
		defList = testParaStyles(curProps);
		if (defList.length > 0) {
			pCtr++;
			curList = new Array ();
			curName = curParaStyles[k].name;
			curGroupName = curParaStyles[k].parent.name;
			curList.push("Absatzformat \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("\r");
			defString = defString + newString + "\r\r";
		}
	}
}

// la fonction qui examine les styles de paragraphes
function testParaStyles(curProps) {
	tmpList = new Array ();
	if (curProps.fillColor != undefined) {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Couleur des caractres");
		}
	}
	if (curProps.strokeColor != undefined) {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Couleur du contour");
		}
	}
	if (curProps.ruleAboveColor != undefined) {
		if (curProps.ruleAboveColor.name == selColor) {
			tmpList.push("  > Filet au-dessus");
		}
	}
	if (curProps.ruleAboveGapColor != undefined) {
		if (curProps.ruleAboveGapColor.name == selColor) {
			tmpList.push("  > Filet au-dessus (espace)");
		}
	}
	if (curProps.ruleBelowColor != undefined) {
		if (curProps.ruleBelowColor.name == selColor) {
			tmpList.push("  > Filet au-dessous");
		}
	}
	if (curProps.ruleBelowGapColor != undefined) {
		if (curProps.ruleBelowGapColor.name == selColor) {
			tmpList.push("  > Filet au-dessous (espace)");
		}
	}
	if (curProps.underlineColor != undefined) {
		if (curProps.underlineColor.name == selColor) {
			tmpList.push("  > Soulignement");
		}
	}
	if (curProps.underlineGapColor != undefined) {
		if (curProps.underlineGapColor.name == selColor) {
			tmpList.push("  > Soulignement (espace)");
		}
	}
	if (curProps.strikeThroughColor != undefined) {
		if (curProps.strikeThroughColor.name == selColor) {
			tmpList.push("  > Texte barr");
		}
	}
	if (curProps.strikeThroughGapColor != undefined) {
		if (curProps.strikeThroughGapColor.name == selColor) {
			tmpList.push("  > Texte barr (espace)");
		}
	}
	return tmpList;
}

//--- dresser la liste des styles de caractres...---//
var allCharStyles = curDoc.characterStyles;
var nCharStyles = allCharStyles.length;

// une boucle  travers la liste, le compteur commence  "1", 
// ainsi on vite "[Aucune]" (non ditable)
var cCtr = 0;
for (var i=1; i<nCharStyles; i++) {
	curList = new Array ();
	curProps = allCharStyles[i].properties;
	defList = testCharStyles(curProps);
	if (defList.length > 0) {
		cCtr++;
		curName = allCharStyles[i].name;
		curList.push("Style de caractres \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("\r");
		defString = defString + newString + "\r\r";
	}
}

//--- lister les groupes de styles de caractres...---//
var allGroups = curDoc.characterStyleGroups;
var nCharStyleGroups = allGroups.length;
var curGroup, curCharStyles, nCharStyles;
for (var i=0; i<nCharStyleGroups; i++) {
	curGroup = allGroups[i];
	curCharStyles = curGroup.allCharacterStyles;
	nCharStyles = curCharStyles.length;
	for (var k=0; k<nCharStyles; k++) {
		curProps = curCharStyles[k].properties;
		defList = testCharStyles(curProps);
		if (defList.length > 0) {
			cCtr++;
			curList = new Array ();
			curName = curCharStyles[k].name;
			curGroupName = curCharStyles[k].parent.name;
			curList.push("Style de caractres \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("\r");
			defString = defString + newString + "\r\r";
		}
	}
}

// la fonction qui examine les styles de caractres
function testCharStyles(curProps) {
	tmpList = new Array ();
	try {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Couleur des caractres");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Couleur du contour");
		}
	}
	catch (e) {
	}
	try {
		unc = curProps.underlineColor;
		if (unc.name == selColor) {
			tmpList.push("  > Soulignement");
		}
	}
	catch (e) {
	}
	try {
		ungc = curProps.underlineGapColor;
		if (ungc.name == selColor) {
			tmpList.push("  > Soulignement (espace)");
		}
	}
	catch (e) {
	}
	try {
		stc = curProps.strikeThroughColor;
		if (stc.name == selColor) {
			tmpList.push("  > Texte barr");
		}
	}
	catch (e) {
	}
	try {
		stgc = curProps.strikeThroughGapColor;
		if (stgc.name == selColor) {
			tmpList.push("  > Texte barr (espace)");
		}
	}
	catch (e) {
	}
	return tmpList;
}

//--- dresser la liste des styles d'objets...---//
var allObjectStyles = curDoc.objectStyles;
var nObjStyles = allObjectStyles.length;

// une boucle  travers la liste, le compteur commence  "1", 
// ainsi on vite "[Aucun]" (non ditable)
var oCtr = 0;
for (var i=1; i<nObjStyles; i++) {
	curStyle = allObjectStyles[i];
	curProps = curStyle.properties;
	defList = testObjStyles(curStyle, curProps);
	if (defList.length > 0) {
		oCtr++;
		curList = new Array ();
		curName = allObjectStyles[i].name;
		curList.push("Style d'objet \"" + curName + "\":");
		newList = curList.concat(defList);
		newString = newList.join("\r");
		defString = defString + newString + "\r\r";
	}
}

//--- lister les groupes de styles d'objets...---//
var	allGroups = curDoc.objectStyleGroups;
var nObjStyleGroups = allGroups.length;
var curGroup, curObjStyles, nObjStyles;
for (var i=0; i<nObjStyleGroups; i++) {
	curGroup = allGroups[i];
	curObjStyles = curGroup.allObjectStyles;
	nObjStyles = curObjStyles.length;
	for (var k=0; k<nObjStyles; k++) {
		curStyle = curObjStyles[k];
		curProps = curObjStyles[k].properties;
		defList = testObjStyles(curStyle, curProps);	
		if (defList.length > 0) {
			cCtr++;
			curList = new Array ();
			curName = curObjStyles[k].name;
			curGroupName = curObjStyles[k].parent.name;
			curList.push("Style d'objet \"" + curName + "\" (" + curGroupName + "):");
			newList = curList.concat(defList);
			newString = newList.join("\r");
			defString = defString + newString + "\r\r";
		}
	}
}

// la fonction qui examine les styles d'objets
function testObjStyles(curStyle, curProps) {
	tmpList = new Array ();
	try {
		if (curProps.fillColor.name == selColor) {
			tmpList.push("  > Fond");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.strokeColor.name == selColor) {
			tmpList.push("  > Contour");
		}
	}
	catch (e) {
	}
	try {
		if (curProps.gapColor.name == selColor) {
			tmpList.push("  > Espace");
		}
	}
	catch (e) {
	}
	try {
		curTransProps = curStyle.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpList.push("  > Ombre");
		}
		else {
			curTransProps = curStyle.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpList.push("  > Ombre");
			}
			else {
				curTransProps = curStyle.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpList.push("  > Ombre");
				}
				else {
					curTransProps = curStyle.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpList.push("  > Ombre");
					}
				}
			}
		}
	}
	catch (e) {
	}
	return tmpList;
}

//--- dresser la liste des styles de tableaux...---//
var allTableStyles = curDoc.tableStyles;
var nTableStyles = allTableStyles.length;

// une boucle  travers la liste, le compteur commence  "1", 
// ainsi on vite "[Aucun]" (non ditable)
var tbsCtr = 0;
curList = new Array ();
for (var i=1; i<nTableStyles; i++) {
	curStyle = allTableStyles[i];
	if (testTableStyles(curStyle)) {
		tbsCtr++;
		curList.push("\"" + curStyle.name + "\"");
	}
}
if (curList.length > 0) {
	var newString = curList.join(", ");
	if (curList.length == 1) {
		defString = defString + "Style de tableau:\t" + newString + "\r\r";
	}
	else {
		defString = defString + "Styles de tableau:\t" + newString + "\r\r";
	}
}

//--- lister les groupes de styles de tableaux...---//
var allGroups = curDoc.tableStyleGroups;
var nTableStyleGroups = allGroups.length;
var curGroup, curTableStyles;
for (var i=0; i<nTableStyleGroups; i++) {
	curGroup = allGroups[i];
	curTableStyles = curGroup.allTableStyles;
	nTableStyles = curTableStyles.length;
	for (var k=0; k<nTableStyles; k++) {
		curStyle = curTableStyles[k];
		if (testTableStyles(curStyle)) {
			tbsCtr++;
			curList = new Array ();
			curName = curTableStyles[k].name;
			curGroupName = curTableStyles[k].parent.name;
			curList.push("Style de tableau \"" + curName + "\" (" + curGroupName + ")");
			newList = curList.concat(defList);
			newString = newList.join("\r");
			defString = defString + newString + "\r\r";
		}
	}
}

// la fonction qui examine les styles de tableaux
function testTableStyles(curStyle) {
	if (curStyle.topBorderStrokeColor != undefined) {
		if (curStyle.topBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.leftBorderStrokeColor != undefined) {
		if (curStyle.leftBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.bottomBorderStrokeColor != undefined) {
		if (curStyle.bottomBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.rightBorderStrokeColor != undefined) {
		if (curStyle.rightBorderStrokeColor.name == selColor) { return true; }}
	if (curStyle.startColumnFillColor != undefined) {
		if (curStyle.startColumnFillColor.name == selColor) { return true; }}
	if (curStyle.endColumnFillColor != undefined) {
		if (curStyle.endColumnFillColor.name == selColor) { return true; }}
	if (curStyle.startRowFillColor != undefined) {
		if (curStyle.startRowFillColor.name == selColor) { return true; }}
	if (curStyle.endRowFillColor != undefined) {
		if (curStyle.endRowFillColor.name == selColor) { return true; }}
	if (curStyle.startColumnStrokeColor != undefined) {
		if (curStyle.startColumnStrokeColor.name == selColor) { return true; }}
	if (curStyle.endColumnStrokeColor != undefined) {
		if (curStyle.endColumnStrokeColor.name == selColor) { return true; }}
	if (curStyle.startRowStrokeColor != undefined) {
		if (curStyle.startRowStrokeColor.name == selColor) { return true; }}
	if (curStyle.endRowStrokeColor != undefined) {
		if (curStyle.endRowStrokeColor.name == selColor) { return true; }}
	if (curStyle.topBorderStrokeGapColor != undefined) {
		if (curStyle.topBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.leftBorderStrokeGapColor != undefined) {
		if (curStyle.leftBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.bottomBorderStrokeGapColor != undefined) {
		if (curStyle.bottomBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.rightBorderStrokeGapColor != undefined) {
		if (curStyle.rightBorderStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.startColumnStrokeGapColor != undefined) {
		if (curStyle.startColumnStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.endColumnStrokeGapColor != undefined) {
		if (curStyle.endColumnStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.startRowStrokeGapColor != undefined) {
		if (curStyle.startRowStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.endRowStrokeGapColor != undefined) {
		if (curStyle.endRowStrokeGapColor.name == selColor) { return true; }}
	{ return false; }
}

//--- dresser la liste des styles de cellules...---//
curList = new Array ();
var allCellStyles = curDoc.cellStyles;
var nCellStyles = allCellStyles.length;

// une boucle  travers la liste, le compteur commence  "1", 
// ainsi on vite "[Aucun]" (non ditable)
var cellCtr = 0;
curList = new Array ();
for (var i=1; i<nCellStyles; i++) {
	curStyle = allCellStyles[i];
	if (testCellStyles(curStyle)) {
		cellCtr++;
		curList.push("\"" + curStyle.name + "\"");
	}
}
if (curList.length > 0) {
	var newString = curList.join(", ");
	if (curList.length == 1) {
		defString = defString + "Style de cellule:\t" + newString + "\r\r";
	}
	else {
		defString = defString + "Styles de cellule:\t" + newString + "\r\r";
	}
}

//--- lister les groupes de styles de cellules...---//
var allGroups = curDoc.cellStyleGroups;
var nCellStyleGroups = allGroups.length;
var curGroup, curCellStyles, nCellStyles;
for (var i=0; i<nCellStyleGroups; i++) {
	curGroup = allGroups[i];
	curCellStyles = curGroup.allCellStyles;
	nCellStyles = curCellStyles.length;
	for (var k=0; k<nCellStyles; k++) {
		curStyle = curCellStyles[k];
		if (testCellStyles(curStyle)) {
			tbsCtr++;
			curList = new Array ();
			curName = curCellStyles[k].name;
			curGroupName = curCellStyles[k].parent.name;
			curList.push("Style de cellule \"" + curName + "\" (" + curGroupName + ")");
			newList = curList.concat(defList);
			newString = newList.join("\r");
			defString = defString + newString + "\r\r";
		}
	}
}

// la fonction qui examine les styles de cellules
function testCellStyles(curStyle) {
	if (curStyle.fillColor != undefined) {
		if (curStyle.fillColor.name == selColor) { return true; }}
	if (curStyle.leftEdgeStrokeColor != undefined) { 
		if (curStyle.leftEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.topEdgeStrokeColor != undefined) {
		if (curStyle.topEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.bottomEdgeStrokeColor != undefined) {
		if (curStyle.bottomEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.rightEdgeStrokeColor != undefined) {
		if (curStyle.rightEdgeStrokeColor.name == selColor) { return true; }}
	if (curStyle.diagonalLineStrokeColor != undefined) {
		if (curStyle.diagonalLineStrokeColor.name == selColor) { return true; }}
	if (curStyle.topEdgeStrokeGapColor != undefined) {
		if (curStyle.topEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.leftEdgeStrokeGapColor != undefined) {
		if (curStyle.leftEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.bottomEdgeStrokeGapColor != undefined) {
		if (curStyle.bottomEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.rightEdgeStrokeGapColor != undefined) {
		if (curStyle.rightEdgeStrokeGapColor.name == selColor) { return true; }}
	if (curStyle.diagonalLineStrokeGapColor != undefined) {
		if (curStyle.diagonalLineStrokeGapColor.name == selColor) { return true; }}
	return false;
}

// examiner les filets de paragraphes et les 'textStyleRanges'
var allStories = curDoc.stories;
var nStories = allStories.length;
var tsr, nTsr, tsrFills, tsrStrks;
var tCtr = nCtr = iCtr = 0;
var raf, rag;
var rafCtr = ragCtr = rafgCtr = 0;
var rbf, rbg;
var rbfCtr = rbgCtr = rbfgCtr = 0;
var aFill, aStrk, fCtr;
var curInsPoint, curInsPoint, insPointStrk; 
for (var i=0; i<nStories; i++) {
	insPointFill = insPointStrk = "";
	curStory = allStories[i];
	// les filets de paragraphes
	allParas = curStory.paragraphs;
	nParas = allParas.length;
	for (var j=0; j<nParas; j++) {
		raf = rag = rbf = rbg = false;
		curProps = allParas[j].properties;
		if (curProps.ruleAboveColor != undefined) {
			if (curProps.ruleAboveColor.name == selColor) {
				raf = checkParaRule(curProps, "ra", "full");
			}
		}
		if (curProps.ruleAboveGapColor != undefined) {
			if (curProps.ruleAboveGapColor.name == selColor) {
				rag = checkParaRule(curProps, "ra", "gap");
			}
		}
		if (raf && rag) { rafgCtr++; }
		else if (raf && !rag) { rafCtr++; }
		else if (!raf && rag) { ragCtr++; }
		if (curProps.ruleBelowColor != undefined) {
			if (curProps.ruleBelowColor.name == selColor) {
				rbf = checkParaRule(curProps, "rb", "full");
			}
		}
		if (curProps.ruleBelowGapColor != undefined) {
			if (curProps.ruleBelowGapColor.name == selColor) {
				rbg = checkParaRule(curProps, "rb", "gap");
			}
		}
		if (rbf && rbg) { rbfgCtr++; }
		else if (rbf && !rbg) { rbfCtr++; }
		else if (!rbf && rbg) { rbgCtr++; }
	}
	// du texte normal
	tsr = curStory.textStyleRanges;
	nTsr = tsr.length;
	if (nTsr > 0) {
		tsrFills = tsr.everyItem().fillColor;
		tsrStrks = tsr.everyItem().strokeColor;
		xCtr = examRanges(nTsr, tsrFills, tsrStrks);
		tCtr = tCtr+xCtr;
		// les notes de bas de page
		nNotes = curStory.footnotes.length;
		if (nNotes > 0) {
			for (var k=0; k<nNotes; k++) {
				tsr = curStory.footnotes[k].texts[0].textStyleRanges;
				nTsr = tsr.length;
				tsrFills = tsr.everyItem().fillColor;
				tsrStrks = tsr.everyItem().strokeColor;
				xCtr = examRanges(nTsr, tsrFills, tsrStrks);
				nCtr = nCtr+xCtr;
			}
		}
	}
	else {
		curInsPoint = curStory.insertionPoints[0];
		if (curInsPoint.fillColor != undefined) {
			insPointFill = curInsPoint.fillColor.name;
		}
		if (curInsPoint.strokeColor != undefined) {
			insPointStrk = curInsPoint.strokeColor.name;
		}
		if (insPointFill == selColor || insPointStrk == selColor) {
			iCtr++;
		}
	}
}

function checkParaRule(curProps, rPos, rType) {
	paraParent = curProps.appliedParagraphStyle;
	paraName   = paraParent.name;
	if (paraName[0] == "[") {
		return true;
	}
	else {
		try {
			if (rPos == "ra") {
				if (rType == "full") {
					if (paraParent.ruleAboveColor != undefined) {
						if (paraParent.ruleAboveColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
				else {
					if (paraParent.ruleAboveGapColor != undefined) {
						if (paraParent.ruleAboveGapColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
			}
			else {
				if (rType == "full") {
					if (paraParent.ruleBelowColor != undefined) {
						if (paraParent.ruleBelowColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
				else {
					if (paraParent.ruleBelowGapColor != undefined) {
						if (paraParent.ruleBelowGapColor.name != selColor) {
							return true;
						}
						else {
							return false;
						}
					}
				}
			}
		}
		catch (e) {
		}
	}
}

function examRanges(nTsr, tsrFills, tsrStrks) {
	var xCtr = 0;
	for (var j=nTsr-1; j>-1; j--) {
		aFill = aStrk = false;
		fCtr = 0;
		try {
			if (tsrFills[j].name == selColor) {
				aFill = true;
			}
			if (tsrStrks[j].name == selColor) {
				aStrk = true;
			}
		}
		catch (e) {
		}
		if (aFill || aStrk) {
			paraParent = tsr[j].appliedParagraphStyle;
			paraName   = paraParent.name;
			charParent = tsr[j].appliedCharacterStyle;
			charName   = charParent.name;
			if (paraName[0] == "[" && charName[0] == "[") {
				xCtr++;
			}
			else {
				if (aFill) {
					try {
						if (paraParent.fillColor.name != selColor) {
							xCtr++;
							fCtr++;
						}
						if (charParent.fillColor.name == selColor) {
							if (fCtr > 0) {
								xCtr--;
							}
							else {
								xCtr++;
								fCtr++;
							}
						}
					}
					catch (e) {
					}
				}
				if (fCtr == 0) {
					if (aStrk) {
						try {
							if (curDoc.paragraphStyles.item(paraParent).strokeColor.name != selColor) {
								xCtr++;
							}
							else if (curDoc.characterStyles.item(charParent).strokeColor.name != selColor) {
								xCtr++;
							}
						}
						catch (e) {
						}
					}
				}
			}
		}
	}
	return xCtr;
}

// les blocs
var allFrames = curDoc.allPageItems;
var nFrames = allFrames.length;
var curFrame, curProps, curTransProps;
var tmpCtr;
var txtCtr = txtFill = txtStrk = txtGap = txtShw = 0;
var unaCtr = unaFill = unaStrk = unaGap = unaShw = 0;
var imgCtr = imgFill = imgStrk = imgGap = imgShw = imgCol = 0;
var linCtr = linFill = linStrk = linGap = linShw = 0;
var grpCtr = grpShw = 0;
var uknCtr = uknFill = uknStrk = uknGap = uknShw = 0;
for (var i=0; i<nFrames; i++) {
	tmpCtr = 0;
	curFrame = allFrames[i];
	curProps = curFrame.properties;
	curTransProps = "";
	if (curFrame == "[object TextFrame]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				txtFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				txtStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				txtGap++;
			}
		}
		curTransProps = curFrame.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			txtShw++;
		}
		else {
			curTransProps = curFrame.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				txtShw++;
			}
			else {
				curTransProps = curFrame.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					txtShw++;
				}
				else {
					curTransProps = curFrame.contentTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						txtShw++;
					}
				}
			}
		}
		if (tmpCtr > 0) {
			txtCtr++;
		}
	}
	else if (curFrame == "[object Rectangle]" || curFrame == "[object Oval]" || curFrame == "[object Polygon]") {
		if (curProps.contentType == 1970168179) {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor.name == selColor) {
					tmpCtr++;
					unaFill++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
					unaStrk++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
					unaGap++;
				}
			}
			curTransProps = curProps.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				unaShw++;
			}
			else {
				curTransProps = curProps.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					unaShw++;
				}
				else {
					curTransProps = curProps.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						unaShw++;
					}
				}
			}
			if (tmpCtr > 0) {
				unaCtr++;
			}
		}
		else {
			if (curProps.fillColor != undefined) {
				if (curProps.fillColor != undefined) {
					tmpCtr++;
					imgFill++;
				}
			}
			if (curProps.strokeColor != undefined) {
				if (curProps.strokeColor.name == selColor) {
					tmpCtr++;
					imgStrk++;
				}
			}
			if (curProps.gapColor != undefined) {
				if (curProps.gapColor.name == selColor) {
					tmpCtr++;
					imgGap++;
				}
			}
			curTransProps = curProps.transparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				imgShw++;
			}
			else {
				curTransProps = curProps.strokeTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					imgShw++;
				}
				else {
					curTransProps = curProps.fillTransparencySettings;
					if (testShadow(curTransProps, selColor)) {
						tmpCtr++;
						imgShw++;
					}
				}
			}
			try {
				if (curFrame.graphics[0].properties.fillColor != undefined) {
					if (curFrame.graphics[0].properties.fillColor.name == selColor) {
						tmpCtr++;
						imgCol++;
					}
				}
			}
			catch (e) {
			}
			if (tmpCtr > 0) {
				imgCtr++;
			}
		}
	}
	else if (curFrame == "[object GraphicLine]") {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				linFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				linStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				linGap++;
			}
		}
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			linShw++;
		}
		else {
			curTransProps = curProps.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				linShw++;
			}
			else {
				curTransProps = curProps.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					linShw++;
				}
			}
		}
		if (tmpCtr > 0) {
			linCtr++;
		}
	}
	else if (curFrame == "[object Group]") {
		// die Elemente der Gruppen sind zwei Mal vorhanden, deshalb:
		// nur die Gruppen-Effekte prfen 
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			grpCtr++;
			grpShw++;
		}
	}
	else {
		if (curProps.fillColor != undefined) {
			if (curProps.fillColor.name == selColor) {
				tmpCtr++;
				uknFill++;
			}
		}
		if (curProps.strokeColor != undefined) {
			if (curProps.strokeColor.name == selColor) {
				tmpCtr++;
				uknStrk++;
			}
		}
		if (curProps.gapColor != undefined) {
			if (curProps.gapColor.name == selColor) {
				tmpCtr++;
				uknGap++;
			}
		}
		curTransProps = curProps.transparencySettings;
		if (testShadow(curTransProps, selColor)) {
			tmpCtr++;
			uknShw++;
		}
		else {
			curTransProps = curProps.strokeTransparencySettings;
			if (testShadow(curTransProps, selColor)) {
				tmpCtr++;
				uknShw++;
			}
			else {
				curTransProps = curProps.fillTransparencySettings;
				if (testShadow(curTransProps, selColor)) {
					tmpCtr++;
					uknShw++;
				}
			}
		}
		if (tmpCtr > 0) {
			uknCtr++;
		}
	}
}

// les tableaux
tabCtr = 0;
var allStories = curDoc.stories;
var nStories = allStories.length;
var nTables, curTable;
var allCells, allColors, curTest, nCells;
for (var i=0; i<nStories; i++) {
	nTables = allStories[i].tables.length;
	for (var k=0; k<nTables; k++) {
		curTable = allStories[i].tables[k];
		for (var m=0; m<1; m++) {
			if (curTable.topBorderStrokeColor != undefined) {
				if (curTable.topBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeColor != undefined) {
				if (curTable.leftBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeColor != undefined) {
				if (curTable.bottomBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeColor != undefined) {
				if (curTable.rightBorderStrokeColor.name == selColor) { tabCtr++; break; }}
			if (curTable.topBorderStrokeGapColor != undefined) {
				if (curTable.topBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.leftBorderStrokeGapColor != undefined) {
				if (curTable.leftBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.bottomBorderStrokeGapColor != undefined) {
				if (curTable.bottomBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			if (curTable.rightBorderStrokeGapColor != undefined) {
				if (curTable.rightBorderStrokeGapColor.name == selColor) { tabCtr++; break; }}
			
			allCells = curTable.cells.everyItem();
			allColors = allCells.fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.topEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.leftEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.bottomEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.rightEdgeStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			allColors = allCells.diagonalLineStrokeGapColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
			
			allColors = allCells.texts[0].textStyleRanges.everyItem().fillColor;
			curTest = testItems(allColors);
			if (curTest) { tabCtr++; break; }
		}
	}
}

// informer l'utilisateur
var totCtr = pCtr + cCtr + oCtr + tbsCtr + cellCtr + tCtr + nCtr + rafCtr + ragCtr + rafgCtr + rbfCtr + rbgCtr + rbfgCtr + iCtr + txtCtr + imgCtr + unaCtr + linCtr + grpCtr + uknCtr + tabCtr;
if (totCtr == 0) {
	alert ("La nuance recherche  \"" + selColor + "\"\n\nest introuvable.", "Stop");
}
else {
	// mmoriser le calque actif, dverrouiller, le cas chant
	var lockLayer = false;
	var actLayer = app.activeWindow.activeLayer;
	if (actLayer.locked == true) {
		actLayer.locked = false;
		lockLayer = true;
	}
	
	// supprimer le bloc "rapport" (s'il est prsent)
	try {
		curDoc.textFrames.item("report").remove();
	}
	catch (e) {
	}
	
	// mettre le point zro  zro/zro
	curDoc.zeroPoint = [0,0];
	
	// mettre le dfaut du style de caractres  "Aucun"
	var noCharStyle = curDoc.characterStyles.item(0);
	curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
	// mettre le dfaut du style de paragraphes  "Paragraphe Standard"
	var dfParaStyle = curDoc.paragraphStyles.item(1);
	curDoc.textDefaults.appliedParagraphStyle = dfParaStyle;
	
	// prparer la chane
	if (totCtr == 1) {
		defString = "Application de la nuance \"" + selColor + "\" trouve:\r\r" + defString;
	}
	else {
		defString = "Applications de la nuance \"" + selColor + "\" trouves:\r\r" + defString;
	}
	
	if (tCtr > 0) {
		if (tCtr > 1) {
			defString = defString + "Chanes de texte:\t" + tCtr + "  ranges \"text style\"  (sans styles; ou formatage local diffrent)\r\r";
		}
		else {
			defString = defString + "Chane de texte:\t" + tCtr + "  range \"text style\"  (sans style; ou formatage local diffrent)\r\r";
		}
	}
	
	if (iCtr > 0) {
		if (iCtr > 1) {
			defString = defString + "Points d'insertion:\t" + iCtr + "  (dans des blocs texte vides)\r\r";
		}
		else {
			defString = defString + "Point d'insertion:\t" + iCtr + "  (dans un bloc texte vide)\r\r";
		}
	}
	
	if (nCtr > 0) {
		if (nCtr > 1) {
			defString = defString + "Notes bas de page:\t" + nCtr + " ranges \"text style\"  (sans styles; ou formatage local diffrent)\r\r";
		}
		else {
			defString = defString + "Note bas de page:\t" + nCtr + " range \"text style\"  (sans style; ou formatage local diffrent)\r\r";
		}
	}
	
	if (rafCtr > 0) {
		if (rafCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + rafCtr + "  Filets au-dessus  (couleur)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + rafCtr + "  Filet au-dessus  (couleur)\r\r";
		}
	}
	if (ragCtr > 0) {
		if (ragCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + ragCtr + "  Filets au-dessus (seul. espace)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + ragCtr + "  Filet au-dessus (seul. espace)\r\r";
		}
	}
	if (rafgCtr > 0) {
		if (rafgCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + rafgCtr + "  Filets au-dessus (couleur + espace)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + rafgCtr + "  Filet au-dessus (couleur + espace)\r\r";
		}
	}
	
	if (rbfCtr > 0) {
		if (rbfCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + rbfCtr + "  Filets au-dessous  (couleur)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + rbfCtr + "  Filet au-dessous  (couleur)\r\r";
		}
	}
	
	if (rbgCtr > 0) {
		if (rbgCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + rbgCtr + "  Filets au-dessous (seul. espace)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + rbgCtr + "  Filet au-dessous (seul. espace)\r\r";
		}
	}
	
	if (rbfgCtr > 0) {
		if (rbfgCtr > 1) {
			defString = defString + "Filets de paragraphes:\t" + rbfgCtr + "  Filets au-dessous (couleur + espace)\r\r";
		}
		else {
			defString = defString + "Filet de paragraphes:\t" + rbfgCtr + "  Filet au-dessous (couleur + espace)\r\r";
		}
	}
	
	if (txtCtr > 0) {
		defString = defString + "Blocs textes:\t" + txtCtr + "  (fond: " + txtFill + " / contour: " + txtStrk + " / espace: " + txtGap + " / ombre: " + txtShw + ")\r\r";
	}
	
	if (imgCtr > 0) {
		if (imgCol == 0) {
			defString = defString + "Blocs images:\t" + imgCtr + "  (fond: " + imgFill + " / contour: " + imgStrk + " / espace: " + imgGap + " / ombre: " + imgShw + ")\r\r";
		}
		else {
			defString = defString + "Blocs images:\t" + imgCtr + "  (fond: " + imgFill + " / contour: " + imgStrk + " / espace: " + imgGap + " / ombre: " + imgShw + " / image: " + imgCol + ")\r\r";
		}
	}
	
	if (unaCtr > 0) {
		defString = defString + "Blocs sans:\t" + unaCtr + "  (fond: " + unaFill + " / contour: " + unaStrk + " / espace: " + unaGap + " / ombre: " + unaShw + ")\r\r";
	}
	
	if (linCtr > 0) {
		defString = defString + "Blocs traits:\t" + linCtr + "  (fond: " + linFill + " / contour: " + linStrk + " / espace: " + linGap + " / ombre: " + linShw + ")\r\r";
	}
	
	if (grpCtr > 0) {
		defString = defString + "Groupes:\t" + grpCtr + "  (Schatten: " + grpShw + ")\r\r";
	}
	
	if (uknCtr > 0) {
		defString = defString + "Blocs inconnus:\t" + uknCtr + "  (fond: " + uknFill + " / contour: " + uknStrk + " / espace: " + uknGap + " / ombre: " + uknShw + ")\r\r";
	}
	
	if (tabCtr > 0) {
		defString = defString + "Tableaux:\t" + tabCtr;
	}
	
	// crer un bloc texte...
	var repFrame = curDoc.pages[0].textFrames.add();
	repFrame.properties = {geometricBounds:["10mm", "10mm", "285mm", "170mm"], fillColor:"Yellow", fillTint:30, label:"report"};
	repFrame.textFramePreferences.insetSpacing = ["3mm", "3mm", "6mm", "0mm"];
	// ... copier la chane prpare dans ce bloc...
	repFrame.parentStory.contents = defString;
	try {
		for (var i=0; i<3; i++) {
			lastChar = repFrame.parentStory.characters.item(-1);
			if (lastChar.contents == "\r") {
				lastChar.remove();
			}
		}
	}
	catch (e) {
	}
	// ... l'ajuster au contenu...
	repFrame.fit(FitOptions.frameToContent);
	// ... et l'afficher
	app.select(repFrame,SelectionOptions.replaceWith);
	app.activeWindow.zoom = ZoomOptions.fitPage;
	app.activeWindow.zoomPercentage = 150;
	app.selection = null;
	
	// rtablir le verrouillage, si ncessaire
	if (lockLayer) {
		actLayer.locked = true;
	}
}

// la fonction qui examine les couleurs
function testItems(allColors) {
	var nCol = allColors.length;
	for (var c=0; c<nCol; c++) {
		try {
			if (allColors[c].name == selColor) {
				return true;
			}
		}
		catch (e) {
		}
	}
	return false;
}

// la fonction qui examine les ombres
function testShadow(curTransProps, selColor) {
	try {
		if (curTransProps.dropShadowSettings.effectColor != undefined) {
			if (curTransProps.dropShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerShadowSettings.effectColor != undefined) {
			if (curTransProps.innerShadowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.outerGlowSettings.effectColor != undefined) {
			if (curTransProps.outerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.innerGlowSettings.effectColor != undefined) {
			if (curTransProps.innerGlowSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.shadowColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.shadowColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.bevelAndEmbossSettings.highlightColor != undefined) {
			if (curTransProps.bevelAndEmbossSettings.highlightColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	try {
		if (curTransProps.satinSettings.effectColor != undefined) {
			if (curTransProps.satinSettings.effectColor.name == selColor) { return true; }}
	}
	catch (e) {
	}
	return false;
}